-- name: [CS] Saul & Friends!
-- description: This Mod Is Pretty Cool - MOD BY SAUL

local E_MODEL_SAUL = smlua_model_util_get_id("sauls_geo")
local E_MODEL_BLAZE = smlua_model_util_get_id("blazing_geo")
local E_MODEL_BIZZY = smlua_model_util_get_id("bizzy_geo")
local E_MODEL_OCTI = smlua_model_util_get_id("octi_geo")
local E_MODEL_PHANBY = smlua_model_util_get_id("phanby_geo")
local E_MODEL_BROB = smlua_model_util_get_id("brob2nd_geo")
local E_MODEL_SONKS = smlua_model_util_get_id("sonks_geo")
local E_MODEL_MARTE = smlua_model_util_get_id("marten_geo")

local TEX_SAUL = get_texture_info("saul-icon")
local TEX_BLAZE = get_texture_info("blaze-icon")
local TEX_BIZZY = get_texture_info("bizzy-icon")
local TEX_OCTI = get_texture_info("octi-icon")
local TEX_PHANBY = get_texture_info("phanby-icon")
local TEX_BROB = get_texture_info("brob2nd-icon")
local TEX_SONKS = get_texture_info("sonks-icon")
local TEX_MARTE = get_texture_info("marten-icon")

local TEX_MOD_NAME = ("[CS] Saul")
local TEX_MOD_NAME = ("[CS] TheBlazingMo")
local TEX_MOD_NAME = ("[CS] BizzareScape")
local TEX_MOD_NAME = ("[CS] Octi")
local TEX_MOD_NAME = ("[CS] Phanuby")
local TEX_MOD_NAME = ("[CS] Brobgonal 2nd")
local TEX_MOD_NAME = ("[CS] Sonks 2nd")
local TEX_MOD_NAME = ("[CS] Marten")

local ANIMTABLE_SAUL = {
    [CHAR_ANIM_STAR_DANCE] = "MARIO_ANIM_CLUB_DANCE",
    [CHAR_ANIM_DOUBLE_JUMP_FALL] = "SAUL_ANIM_4C",
}

local ANIMTABLE_MART = {
    [CHAR_ANIM_RUNNING] = "MARTEN_ANIM_RUN",
}

local PALETTE_BLAZE =  {
    [PANTS]  = { r = 0xff, g = 0x00, b = 0x00 }, -- ff0000
    [SHIRT]  = { r = 0xff, g = 0x00, b = 0x00 }, -- ff0000
    [GLOVES] = { r = 0x5c, g = 0x37, b = 0x24 }, -- 5c3724
    [SHOES]  = { r = 0x95, g = 0x97, b = 0xab }, -- 9597ab
    [HAIR]   = { r = 0x00, g = 0x00, b = 0x00 }, -- 000000
    [SKIN]   = { r = 0xa5, g = 0x5b, b = 0x3e }, -- a55b3e
    [CAP]    = { r = 0xff, g = 0x00, b = 0x00 }, -- ff0000
    [EMBLEM] = { r = 0xff, g = 0x00, b = 0x00 }, -- ff0000
}

local PALETTE_SAUL =  {
    [PANTS]  = { r = 0x24, g = 0x0f, b = 0x5b }, -- 240f5b
    [SHIRT]  = { r = 0xb2, g = 0xcc, b = 0x66 }, -- b2cc66
    [GLOVES] = { r = 0xff, g = 0xff, b = 0xff }, -- FFFFFF
    [SHOES]  = { r = 0x64, g = 0x1c, b = 0x0e }, -- 641c0e
    [HAIR]   = { r = 0x4b, g = 0x06, b = 0x00 }, -- 4b0600
    [SKIN]   = { r = 0xfe, g = 0xc2, b = 0x8d }, -- FEC28d
    [CAP]    = { r = 0xb2, g = 0xcc, b = 0x66 }, -- b2cc66
    [EMBLEM] = { r = 0xb2, g = 0xcc, b = 0x66 }, -- b2cc66
}

local PALETTE_BIZZY =  {
    [PANTS]  = { r = 0xc5, g = 0x91, b = 0x00 }, -- C59100
    [SHIRT]  = { r = 0x00, g = 0x00, b = 0x00 }, -- 000000
    [GLOVES] = { r = 0x00, g = 0x00, b = 0x00 }, -- FFFFFF
    [SHOES]  = { r = 0x68, g = 0x40, b = 0x1B }, -- 68401B
    [HAIR]   = { r = 0x00, g = 0x00, b = 0x00 }, -- 000000
    [SKIN]   = { r = 0x00, g = 0x00, b = 0x00 }, -- 000000
    [CAP]    = { r = 0x6e, g = 0xc2, b = 0xd2 }, -- 6EC2D8
    [EMBLEM] = { r = 0x31, g = 0x31, b = 0x31 }, -- 313131
}

local PALETTE_PHANBY =  {
    [PANTS]  = { r = 0x1b, g = 0x1b, b = 0x4e }, -- 1B1B4E
    [SHIRT]  = { r = 0x18, g = 0x18, b = 0x18 }, -- 181818
    [GLOVES] = { r = 0x00, g = 0x00, b = 0x00 }, -- FFFFFF
    [SHOES]  = { r = 0x00, g = 0x00, b = 0x00 }, -- 000000
    [HAIR]   = { r = 0x00, g = 0x00, b = 0x00 }, -- 000000
    [SKIN]   = { r = 0x00, g = 0x00, b = 0x00 }, -- 000000
    [CAP]    = { r = 0xff, g = 0x00, b = 0x04 }, -- FF0004
    [EMBLEM] = { r = 0x00, g = 0x00, b = 0x00 }, -- 000000
}

local PALETTE_BROB =  {
    [PANTS]  = { r = 0x1b, g = 0x1b, b = 0x4e }, -- 1B1B4E
    [SHIRT]  = { r = 0x2b, g = 0x2b, b = 0x7e }, -- 2B2B7E
    [GLOVES] = { r = 0x00, g = 0x00, b = 0x00 }, -- 000000
    [SHOES]  = { r = 0x00, g = 0x00, b = 0x00 }, -- 000000
    [HAIR]   = { r = 0x00, g = 0x00, b = 0x00 }, -- 000000
    [SKIN]   = { r = 0x55, g = 0x3a, b = 0x19 }, -- 553A19
    [CAP]    = { r = 0xff, g = 0x00, b = 0x04 }, -- FF0004
    [EMBLEM] = { r = 0x00, g = 0x00, b = 0x00 }, -- 000000
}

local PALETTE_MARTE =  {
    [PANTS]  = { r = 0x00, g = 0x00, b = 0x00 }, -- 000000
    [SHIRT]  = { r = 0xff, g = 0xff, b = 0x00 }, -- FFFF00
    [GLOVES] = { r = 0x00, g = 0x00, b = 0x00 }, -- 000000
    [SHOES]  = { r = 0xff, g = 0xff, b = 0x00 }, -- FFFF00
    [HAIR]   = { r = 0x00, g = 0x00, b = 0x00 }, -- 000000
    [SKIN]   = { r = 0xfe, g = 0xc2, b = 0x8d }, -- FEC28d
    [CAP]    = { r = 0xff, g = 0xff, b = 0x00 }, -- FFFF00
    [EMBLEM] = { r = 0xff, g = 0xff, b = 0x00 }, -- FFFF00
}

local TEXT_MOD_NAME = "Saul!"
local TEXT_MOD_NAME = "BlazingMo!"
local TEXT_MOD_NAME = "BizzareScape!"
local TEXT_MOD_NAME = "Octi!"
local TEXT_MOD_NAME = "Phanuby!"
local TEXT_MOD_NAME = "Brobgonal The Second!"
local TEXT_MOD_NAME = "Sonks!"
local TEXT_MOD_NAME = "Marten!"

local VOICETABLE_NONE = {nil}

if _G.charSelectExists then
    _G.charSelect.character_add("Saul", {"Everybody's favorite private sm64 modder."}, "Saul", {r = 178, g = 204, b = 102}, E_MODEL_SAUL, CT_MARIO, TEX_SAUL)
    _G.charSelect.character_add("BlazingMo", {"Cool Bloke."}, "Saul & TheBlazingMo", {r = 65, g = 165, b = 193}, E_MODEL_BLAZE, CT_MARIO, TEX_BLAZE)
    _G.charSelect.character_add("BizzareScape", {"CoopDX Content Creator."}, "Saul", {r = 149, g = 149, b = 149}, E_MODEL_BIZZY, CT_TOAD, TEX_BIZZY)
    _G.charSelect.character_add("Octi", {"Octi Sounds Like Octopus."}, "Saul and Octi", {r = 249, g = 222, b = 11}, E_MODEL_OCTI, CT_TOAD, TEX_OCTI)
    _G.charSelect.character_add("Phanuby", {"Very Cool Fella."}, "Saul and Phanuby", {r = 255, g = 255, b = 255}, E_MODEL_PHANBY, CT_LUIGI, TEX_PHANBY)
    _G.charSelect.character_add("Brobgonal The Second", {"Golden Apple Reference?."}, "Saul", {r = 58, g = 58, b = 181}, E_MODEL_BROB, CT_TOAD, TEX_BROB)
    _G.charSelect.character_add("Sonks_132", {"Sonic Name Goes Crazy?."}, "Mr Maxi", {r = 158, g = 68, b = 81}, E_MODEL_SONKS, CT_MARIO, TEX_SONKS)
    _G.charSelect.character_add("Marten", {"Marten Marten Marten Marten Marten Marten Marten Marten ?."}, "Marten (coop port by saul)", {r = 255, g = 255, b = 0}, E_MODEL_MARTE, CT_MARIO, TEX_MARTE)
    _G.charSelect.character_add_palette_preset(E_MODEL_SAUL, PALETTE_SAUL)
    _G.charSelect.character_add_palette_preset(E_MODEL_BLAZE, PALETTE_BLAZE)
    _G.charSelect.character_add_palette_preset(E_MODEL_BIZZY, PALETTE_BIZZY)
    _G.charSelect.character_add_palette_preset(E_MODEL_PHANBY, PALETTE_PHANBY)
    _G.charSelect.character_add_palette_preset(E_MODEL_BROB, PALETTE_BROB)
    _G.charSelect.character_add_palette_preset(E_MODEL_MARTE, PALETTE_MARTE)
    _G.charSelect.character_add_animations(E_MODEL_SAUL, ANIMTABLE_SAUL)
    _G.charSelect.character_add_animations(E_MODEL_MARTE, ANIMTABLE_MART)
    _G.charSelect.character_add_voice(E_MODEL_SAUL, VOICETABLE_NONE)
    _G.charSelect.character_add_voice(E_MODEL_BLAZE, VOICETABLE_NONE)
    _G.charSelect.character_add_voice(E_MODEL_BIZZY, VOICETABLE_NONE)
    _G.charSelect.character_add_voice(E_MODEL_OCTI, VOICETABLE_NONE)
    _G.charSelect.character_add_voice(E_MODEL_PHANBY, VOICETABLE_NONE)
    _G.charSelect.character_add_voice(E_MODEL_BROB, VOICETABLE_NONE)
    _G.charSelect.character_add_voice(E_MODEL_SONKS, VOICETABLE_NONE)
    _G.charSelect.character_add_voice(E_MODEL_MARTE, VOICETABLE_NONE)
    hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_NONE then return _G.charSelect.voice.sound(m, sound) end
    end)
    hook_event(HOOK_MARIO_UPDATE, function (m)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_NONE then return _G.charSelect.voice.snore(m) end
    end)
else
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
end